# Intro

Mobitec flip-disc displays use MC27C1001 EPROM-s to store the
firmware (?) and fonts.
In the `firmware/` directory you can find two ROM dumps.

# Useful commands

To extract font sections:

```
dd if=mobitec-1682-r7-bib-01979-r3.bin of=mobitec-1682-r7-bib-01979-r3-fonts.bin skip=64 bs=1024
dd if=mobitec-01682-r7-bib-01369-r9.bin of=mobitec-01682-r7-bib-01369-r9-fonts.bin skip=64 bs=1024
```

For diffing font sections:

```
dhex mobitec-1682-r7-bib-01979-r3-fonts.bin mobitec-01682-r7-bib-01369-r9-fonts.bin
```

# Dump structure

The firmware seems to be located in the first 7KiB and the font data
starts at 0x10000 offset.

The font beginning marker seem to consist of a character from `a` to `z`
followed by at least 60 null characters.
They don't seem aligned or indexed in any way so easiest is just to scan
for known markers.

After the beginning marker you can find the lookup table which maps
printable ASCII characters to a glyph address.
The lookup table is 190 bytes (95x 16-bit addresses) which correspond
to ASCII characters 32 up to 126.
Not all fonts include all characters, missing glyphs are represented by address 0.
Note that the glyph address is relative to the beginning of font structure,
beginning marker inclusive.

At the glyph address first width and height of the glyph are found represented
by two 8-bit integers. The actual bitmap data follows in 8x8 pixel tiles
packed together as 8 bytes.


